## START: Set by rpmautospec
## (rpmautospec version 0.7.3)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 3;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%global debug_package %{nil}

Name:			pinesam
Version:		2.2.16
Release:		%autorelease
Summary:		UI for Pinecil V2
License:		MIT
URL:			https://github.com/builder555/PineSAM

Source0:		https://github.com/builder555/PineSAM/archive/v%{version}/%{name}-%{version}.tar.gz
Source1:		%{name}-npm-%{version}.tar.xz
Source2:		%{name}-offline.sh
Source3:		%{name}.service

# Support Python 3.9
Patch0:			pinesam-python39.patch

%{?systemd_requires}
%{?sysusers_requires_compat}
BuildRequires:	systemd-rpm-macros
BuildRequires:  npm
BuildRequires:	python3-devel

Requires:		python3dist(pinecil)
Requires:		python3dist(websockets)
Requires:		python3dist(rich)

%description
UI for Pinecil V2 - control it over BLE from your PC or your mobile.

%prep
%autosetup -p1 -n PineSAM-%{version}
pushd ..
	tar xf %{SOURCE1}
popd

%build
pushd ui
	npm config set offline=true
	npm config set cache ../../%{name}-npm
	npm i
	npx vite build
popd

# Fix paths
sed -i 's!version.txt!%{_datadir}/%{name}/version.txt!g' backend/main.py
sed -i 's!"gui"!"%{_datadir}/%{name}"!g' backend/main.py

# Generate executable
echo '#!/bin/bash

%{__python3} %{python3_sitelib}/%{name}/main.py $@' > %{name}

%install
# Install python sources and bytecompile
mkdir -p %{buildroot}%{python3_sitelib}/%{name}
cp -rf backend/*.py %{buildroot}%{python3_sitelib}/%{name}
%py_byte_compile %{python3} %{buildroot}%{python3_sitelib}/%{name}

# Install npm gui files
mkdir -p %{buildroot}%{_datadir}
cp -rf ui/dist %{buildroot}%{_datadir}/%{name}

# Copy version.txt
cp version.txt %{buildroot}%{_datadir}/%{name}

# Install script
mkdir -p %{buildroot}%{_bindir}
install -m 0755 %{name} %{buildroot}%{_bindir}

# Install systemd unit
mkdir -p %{buildroot}%{_unitdir}
install -m 0644 %{SOURCE3} %{buildroot}%{_unitdir}

%post
%systemd_post pinesam.service

%preun
%systemd_preun pinesam.service

%postun
%systemd_postun_with_restart pinesam.service

%files
%license LICENSE
%{_bindir}/%{name}
%{python3_sitelib}/%{name}/
%{_datadir}/%{name}/
%{_unitdir}/%{name}.service

%changelog
## START: Generated by rpmautospec
* Sat Mar 08 2025 Luca Magrone <luca@magrone.cc> - 2.2.16-1
- Initial package
## END: Generated by rpmautospec
